class HjelpeKlasse {
  
  public static void sortVedUtvalg(Comparable[] tab) {
    // For hvert gjennomlp:
    for (int ind = 0; ind < tab.length - 1; ind++) {
      // Finn minste-verdi i usortert del av tabellen
      int indTilMinste = ind;
      for (int k = ind + 1; k < tab.length; k++) {
        if (tab[k].compareTo(tab[indTilMinste]) < 0) {
          indTilMinste = k ;
        }
      }
      // Bytt om minste-verdi og frste element i usortert del
      Comparable temp = tab[ind];
      tab[ind] = tab[indTilMinste];
      tab[indTilMinste] = temp;
    }
  }
  
  public static void boblesorteringMedObjekter(Comparable[] tab) {
    boolean sortert = false;
    for (int i = tab.length -1; (i > 0) && (!sortert); i--) {
      sortert = true;
      System.out.println("Pass: " + (tab.length - i));
      for (int k = 0; k < i; k++)
        if (tab[k].compareTo(tab[k+1]) > 0) {
        // ombytting
        Comparable temp = tab[k];
        tab[k] = tab[k+1];
        tab[k+1] = temp;
        sortert = false;
      }
    }
  }
  
  public static void sorter(Comparable[] tab) {
    // For hvert gjennomlp:
    for (int neste=1; neste<tab.length; neste++) {
      // Ta vare p neste-verdi som skal innsettes
      Comparable verdi = tab[neste];
      // Forskyv alle verdier i sortert deltabell som er strre enn
      // neste verdi ett hakk bakover i tabellen
      int dette; // indeks for riktig plassering av verdi
      for (dette=neste; dette>0 && verdi.compareTo(tab[dette-1])<0; dette--) {
        tab[dette] = tab[dette-1]; // flytt bakover!
      }
      tab[dette] = verdi;
      skrivTabell(tab, neste+". gjennomlp: ");
    }
  }
  
  public static void skrivTabell(Object[] tab, String ledetekst) {
    System.out.print(ledetekst);
    for (Object verdi: tab)
      System.out.print(verdi + " ");
    System.out.println();
  }
  
  public static int linaersoek(Object[] tab, Object nkkel) {
    int teller;
    for (teller = 0; 
         teller < tab.length && !(tab[teller].equals(nkkel));
         ++teller);   
    // !(teller < tab.length && !(tab[teller].equals(nkkel)) <=>
    //  (teller >= tab.length || tab[teller].equals(nkkel))
    assert (teller >= tab.length || tab[teller].equals(nkkel)) : "Feil i linrt sk";
    boolean funnet = (teller < tab.length);
    if (funnet)
      System.out.println(nkkel + " funnet i element med indeks " + teller);
    else
      System.out.println(nkkel + " finnes ikke!");
    return teller;  // Returnerer indeksen der nkkel er eller burde vrt.
  }
  
  public static int binsk(Comparable[] tab, Comparable nkkel) {
    int l = 0, h = tab.length - 1, m = -1;
    boolean funnet = false, finnes = true;
    while (finnes && !funnet) {
      m = (l + h) / 2;                            // midten av tabellen
      if (l > h) 
        finnes = false;                  // nkkel finnes ikke
      else {
        int status = tab[m].compareTo(nkkel);  // Sammenlign
        if (status == 0) funnet = true; // nkkel er i tab[m]
        else if (status < 0) l = m + 1; // finnes nkkel,
        // s er den i vre halvparten
        else h = m - 1; // finnes nkkel, s er den i nedre halvparten
      }
    }
    // !(finnes && !funnet) <=> (!finnes || funnet)
    assert (!finnes || funnet) : "Feil i binrt sk";
    if (funnet)
      System.out.println(nkkel + " funnet i element med indeks " + m);
    else
      System.out.println(nkkel + " finnes ikke!");
    return m;  // Returnerer indeksen der nkkel er eller burde vrt.
  }
}