
public class Vare implements Comparable {
  String varenavn;   // navn p det som kan kjpes
  int beholdning;    // antallet som er ikke solgt

  Vare(String varenavn, int beholdning) {
    this.varenavn = varenavn;
    this.beholdning = beholdning;
  }

  public String hentVarenavn() { return varenavn; }
  public int hentBeholdning() { return beholdning; }
  public void settVarenavn(String varenavn) {
    this.varenavn = varenavn;
  }

  public void settBeholdning(int beholdning) {
    this.beholdning = beholdning;
  }

  @Override
  public int compareTo(Object obj) {
    if (this == obj) return 0;
    Vare vare = (Vare) obj;
    int status = this.varenavn.compareTo(vare.varenavn);
    if (status == 0) { // samme varenavn?
      status = this.beholdning - vare.beholdning;
    }
    return status;
  }

  @Override
  public boolean equals(Object obj) {  // Samsvar med compareTo()
    if (!(obj instanceof Vare))
      return false;
    return this.compareTo(obj) == 0;
  }

  @Override
  public String toString() { // overkjrer toString() fra Object-klassen
    return "\nVarenavn: " + varenavn +
    "\tBeholdning: " + beholdning;
  }
}